!vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv!
!                                                                      !
!  Module name: URS0_DES                                               !
!                                                                      !
!  Purpose: This routine is called before the discrete phase time loop !
!  and is user-definable. The user may insert code in this routine or  !
!  call appropriate user defined subroutines.                          !
!                                                                      !
!  This routine is not called from a loop, hence all indices are       !
!  undefined.                                                          !
!                                                                      !
!  Author: J.Musser                                   Date: 06-Nov-12  !
!                                                                      !
!  Comments:                                                           !
!                                                                      !
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^!
      SUBROUTINE USR0_DES

      Use des_rxns
      Use des_thermo
      Use discretelement,only:MAX_PIP,DES_POS_NEW,des_radius!获取颗粒位置，最大颗粒数
      Use run
      Use usr
      USE param1, only: zero
      USE des_thermo, only: flpc, calc_cond_des, des_t_s, q_source
      USE constant,only:Pi!调用圆周率常数
      IMPLICIT NONE
      INTEGER :: LL
      double precision :: distance
      double precision :: q_extra
       DO LL = 1,MAX_PIP !颗粒循环
          distance =  DES_POS_NEW(LL,2)+0.08d0  !计算颗粒与源项的位置
          IF(distance.ge.zero) then
             q_extra = des_radius(LL)**2*pi*4*1927.339d0
             q_source(LL) = q_source(LL) + q_extra
          endif
      enddo

      RETURN
      END SUBROUTINE USR0_DES
